
;Alpha Strip - DednDave, 3-2012

        .MODEL  Small
        .DOSSEG                     ;DOS segment order
        .STACK  1024
        OPTION  CaseMap:None        ;case sensitive

;####################################################################

;equate(s)

BUFSIZE EQU 99                      ;user input buffer size, 255 max

;####################################################################

;structure(s)

INBUFFER  STRUCT
  MaxBytes  db ?
  UsedBytes db ?
  Buffer    db BUFSIZE+1 dup(?)
INBUFFER  ENDS

;####################################################################

        .DATA

s$Prompt1 db 'Enter a String: ',24h
s$AnyKey  db 0Dh,0Ah,'Press Any Key To Exit',24h
s$CrLf    db 0Dh,0Ah,24h

OutBuf    db 5 dup(?),24h

;********************************************************************

        .DATA?

InpBuf  INBUFFER <>

;####################################################################

        .CODE

;********************************************************************

_main   PROC    FAR

;------------------------------------------

;set DS, ES to DGROUP

        ASSUME  DS:DGROUP

        mov     ax,@data
        mov     ds,ax
        mov     es,ax

;------------------------------------------

;initialize input buffer size

        mov    InpBuf.MaxBytes,BUFSIZE+1

;------------------------------------------

;get user input strin

Input0: call    NewLine
        mov     dx,offset s$Prompt1 ;'Enter a String:'
        call    PrStr

;------------------------------------------

;filter the string

;0        null (white space)
;20h      space
;41h-5Ah  A-Z
;61h-7Ah  a-z

        mov     si,dx
        mov     di,dx
        xor     bx,bx

Loop00: lodsb
        test    al,0DFh             ;if it's 0 or 20h - white space
        jz      Loop01

        cmp     al,'A'
        jb      Loop02

        cmp     al,'Z'
        jbe     Loop01

        cmp     al,'a'
        jb      Loop02

        cmp     al,'z'
        ja      Loop02

Loop01: stosb
        inc     bx                  ;count it in BX

Loop02: loop    Loop00

        mov     al,'$'
        stosb

;display the string

        call    StrOut

;display the char count

        mov     ax,bx
        call    UnsDec
        call    StrOut

;------------------------------------------

;wait for a key press

Exit00: mov     dx,offset s$AnyKey  ;'Press Any Key To Exit'
        call    StrOut
        mov     ah,1                ;wait for key
        int     16h                 ;BIOS keyboard call
        mov     ah,0                ;get keyboard character
        int     16h                 ;BIOS keyboard call

;------------------------------------------

;terminate program

        mov     ax,4C00h            ;terminate, return = 0
        int     21h                 ;DOS function call

_main   ENDP

;********************************************************************

NewLine PROC    NEAR
;
;Display a Carriage Return/Line Feed
;
;Call With: Nothing
;
;  Returns: Nothing
;
;     Uses: all registers are preserved
;
;------------------------------------------

        push    dx
        push    ax
        mov     dx,offset s$CrLf
        mov     ah,9
        int     21h
        pop     ax
        pop     dx
        ret

NewLine ENDP

;********************************************************************

StrOut  PROC    NEAR
;
;Display a String Followed by Carriage Return/Line Feed
;
;Call With: DX = address of '$' terminated string to display
;
;  Returns: Nothing
;
;     Uses: all registers are preserved
;
;------------------------------------------

        push    ax
        mov     ah,9
        int     21h
        call    NewLine
        pop     ax
        ret

StrOut  ENDP

;********************************************************************

PrStr   PROC    NEAR
;
;Get User Input String With Prompt
;
;Call With: DX = address of prompt string to display
;
;  Returns: CX = number of characters entered
;           DX = address of '$' terminated user entered string
;
;Also Uses: all other registers are preserved
;           the "InpBuf" buffer is used to hold the string
;
;------------------------------------------

        push    ax
        push    bx
        mov     ah,9
        int     21h
        mov     dx,offset InpBuf
        mov     ah,0Ah
        int     21h
        call    NewLine
        mov     cl,InpBuf.UsedBytes
        mov     ch,0
        mov     dx,offset InpBuf.Buffer
        mov     bx,cx
        add     bx,dx
        mov byte ptr [bx],'$'
        pop     bx
        pop     ax
        ret

PrStr   ENDP

;********************************************************************

UnsDec  PROC    NEAR
;
;Convert a 16-Bit Unsigned Integer to ASCII Decimal String
;
;Call With: AX = unsigned binary integer
;
;  Returns: DX = address of '$'-terminated ASCII decimal string
;           CX = length of ASCII decimal string
;
;Also Uses: all other registers are preserved
;           the "OutBuf" buffer is used to hold the string
;
;------------------------------------------

        push    di
        push    bx
        push    ax
        mov     di,offset OutBuf+sizeof OutBuf-1
        mov     bx,10               ;BX = divisor
        push    di

UnDec0: xor     dx,dx               ;zero the high word
        dec     di                  ;point to next string byte
        div     bx                  ;divide DX:AX by 10
        or      dl,30h              ;set ASCII bits in remainder
        mov     [di],dl             ;store the numeric character
        or      ax,ax               ;any quotient left ?
        jnz     UnDec0              ;loop until done

        pop     cx
        mov     dx,di               ;DX = address of first char
        sub     cx,di               ;CX = string length
        pop     ax
        pop     bx
        pop     di
        ret

UnsDec  ENDP

;####################################################################

        END     _main

